import inspect
from enum import Enum

from victron_ble.devices import DeviceData


def values2dict(obj: DeviceData) -> dict:
    data = {}
    for name, method in inspect.getmembers(obj, predicate=inspect.ismethod):
        if name.startswith("get_"):
            value = method()
            if isinstance(value, Enum):
                value = value.name.lower()
            if value is not None:
                data[name[4:]] = value
    return data
